Getting Started with Slider Web Component

Smart UI Web Components work with current evergreen browsers and Node 18+ for local tooling; pin package versions to match your project policy.

Smart UI is distributed as the smart-webcomponents NPM package. You can also use the full download from the Download page.

Quick start

  1. Install the package:

    npm install smart-webcomponents

  2. Load the Slider module (ES module script):

    <script type="module" src="node_modules/smart-webcomponents/source/modules/smart.slider.js"></script>

  3. Add the default stylesheet (prefer angular.json / bundler entry in app codebases; for plain HTML use a link):

    <link rel="stylesheet" type="text/css" href="node_modules/smart-webcomponents/source/styles/smart.default.css" />

  4. Add markup in one of two ways - semantic custom element (the component tag is in your HTML) or a host div (you mount programmatically with appendTo):

    Semantic element (id matches the selector in Smart()):

    <smart-slider id="slider"></smart-slider>

    Host container (id matches appendTo on Smart.Slider):

    <div id="sliderContainer"></div>

  5. Initialize after the module loads: define a const sliderOptions object, then either bind with Smart('#slider', ...) on the semantic tag or use new Smart.Slider({ ...sliderOptions, appendTo: '#sliderContainer' }) on the host div:

    <script type="module">
    	import 'node_modules/smart-webcomponents/source/modules/smart.slider.js';
    
    	const sliderOptions = { value: 25 };
    
    	// Option A - semantic <smart-slider> with id="slider"
    	Smart('#slider', class {
    		get properties() {
    			return sliderOptions;
    		}
    	});
    
    	// Option B - host div id="sliderContainer"
    	// const sliderInstance = new Smart.Slider({
    	// 	...sliderOptions,
    	// 	appendTo: '#sliderContainer'
    	// });
    
    	// Option C - constructor(selector, options), then append the returned element yourself
    	// const mySlider = new Smart.Slider('#slider', sliderOptions);
    	// document.body.appendChild(mySlider);
    </script>
    		

    Uncomment Option B when you use the host div; use Option A when you use the semantic element. The Runtime cookbook also documents new Smart.Slider('#slider', sliderOptions) with appendChild, and document.createElement('smart-slider') with .props or Object.assign (all are valid patterns; do not combine overlapping patterns for the same instance unless you intend multiple components).

  6. Serve the folder over HTTP (or use your bundler dev server) and open the page.

Runtime cookbook

Alternative creation patterns and imperative APIs. These are all valid ways to create Smart UI components: semantic markup + Smart(); new Smart.Slider({ ...options, appendTo: '#...' }); new Smart.Slider('#slider', sliderOptions) plus appendChild on the returned element; and document.createElement('smart-slider') then assigning options via .props or Object.assign on the element.

Constructor with a selector string and options, then append the returned element (for example const mySlider = new Smart.Slider('#slider', sliderOptions)):

	const sliderOptions = { value: 25 };
	const mySlider = new Smart.Slider('#slider', sliderOptions);
	document.body.appendChild(mySlider);
	

Create with document.createElement('smart-slider'), assign properties (same as any custom element), then append:

	const sliderOptions = { value: 25 };
	const slider = document.createElement('smart-slider');
	Object.assign(slider, sliderOptions);
	document.body.appendChild(slider);
	

Host on a div with appendTo (import the module, then instantiate when the document is ready; the container id must match appendTo):

	import "../../source/modules/smart.slider.js";

	document.readyState === 'complete' ? init() : window.addEventListener('load', init);

	function init() {
		const sliderOptions = { value: 25 };
		const slider = new Smart.Slider({
			...sliderOptions,
			appendTo: '#sliderContainer'
		});
	}
	

Demo

Note how Smart.element.js and webcomponents.min.js are declared before everything else. This is mandatory for all custom elements.

Also note that the reference to smart.tank.js is declared before Smart.slider.js. This is important because Smart.Slider extends Smart.Tank and reuses most of its methods.


In order to change the value of the slider the value property has to be applied via javascript:

<!DOCTYPE html>
<html lang="en">
<head>
 <link rel="stylesheet" href="../../source/styles/smart.default.css" type="text/css" />
 <script type="text/javascript" src="../../source/modules/smart.slider.js"></script>
 <script>
     window.onload = function () {
         var slider = document.querySelector('smart-slider');
         slider.value = 25;
     }
 </script>
</head>
<body>
 <smart-slider></smart-slider>
</body>
</html>

Demo

or set it as HTML attribute:

<smart-slider value="25"></smart-slider>

Demo

Appearance

Smart.Slider can be either horizontal or vertical. The default orientation is horizontal but that can be changed on initialization in the HTML:

<smart-slider orientation="vertical"></smart-slider>

Demo

or later using javascript:

<!DOCTYPE html>
<html lang="en">
<head>
 <link rel="stylesheet" href="../../source/styles/smart.default.css" type="text/css" />
 <script type="text/javascript" src="../../source/modules/smart.slider.js"></script>

 <script>
     window.onload = function () {
         var slider = document.querySelector('smart-slider');
         slider.orientation = 'vertical';
     }
 </script>
</head>
<body>
 <smart-slider></smart-slider>
</body>
</html>

Demo

Smart.Slider uses a scale to indicate the value. The scale can be positioned above, under or on both sides of the element thanks to the scalePosition property. By default it's located over the element for horizontal slider or before the element for vertical slider.

Let's change the position of the scale via javascript:

<smart-slider scale-position="far"></smart-slider>

Demo

The ticks of the scale can also be customized. They can be positioned above the track or inside it by setting the tickPosition property like so:

<smart-slider ticks-position="track"></smart-slider>

Demo


The scale of the Slider contains major and minor ticks which are visible by default. This can be re-configured. The user can display only the major, the minor or none of them if he prefers by setting the ticksVisibility property. This can also be done in the HTML code on initialization like so:

<smart-slider ticks-visibility="major"></smart-slider>

Demo


The scale of the Slider has ticks and labels. Labels are also customizable. The user can control which of them to be visible:

  • none - no labels are visible
  • all - all labels are visible
  • endPoints - only the first and last labels are visible

The text of the label can also be modified thanks to the labelFormatFunction property. It's a format function that takes one argument - the value of the label. The function must return a string representing the new text for the labels. The property can be applied via javascript like so:

                    <!DOCTYPE html>
<html lang="en">
<head>
  <link rel="stylesheet" href="../../source/styles/smart.default.css" type="text/css" />
 <script type="text/javascript" src="../../source/modules/smart.slider.js"></script>

 <script>
     window.onload = function () {
             var slider = document.querySelector('smart-slider');
             slider.labelFormatFunction = function (value) {
             return value + ' ' + 'in';
         }
     }
 </script>
</head>
<body>
 <smart-slider></smart-slider>
</body>
</html>

Demo

Smart.Slider has control buttons that are hidden by default. They can be enabled by setting the property showButtons. The buttons are positioned in front and after the track scale and can be used to decrease or increase the value of the slider. The property can be set as an attribute in the HTML tag of the element:

<smart-slider show-buttons></smart-slider>

or using javascript:

<!DOCTYPE html>
<html lang="en">
<head>
 <link rel="stylesheet" href="../../source/styles/smart.default.css" type="text/css" />
 <script type="text/javascript" src="../../source/modules/smart.slider.js"></script>
 <script>
     window.onload = function () {
         var slider = document.querySelector('smart-slider');
         slider.showButtons = true;
     }
 </script>
</head>
<body>
 <smart-slider></smart-slider>
</body>
</html>

Demo

Behavior

Smart.Slider allows two types of scales:

  • integer - the values are integers only
  • floatingPoint - the values are floating point numbers

The type of the scale is determined by the scaleType property which can be set on initialization:

<smart-slider scale-type="integer"></smart-slider>

Demo

or changed later when the element is ready using javascript:

<script>
     window.onload = function () {
         var slider = document.querySelector('smart-slider');
         slider.scaleType = 'floatingPoint';
     }
 </script>

Demo

When the scaleType is set to "floatingPoing", the user can adjust the precision of the value via the "precisionDigits" property. This property determines how many numbers will appear after the decimal point of the current value. Can be set like every other property:

<smart-slider precision-digits="2"></smart-slider>

Demo

Smart.Slider allows controlling the number significant digits shown on the scale. The significantDigits property determines how the value will be represented. For example, let's say the user wants to configure the value to contain only 3 significant digits:

<smart-slider significant-digits="3"></smart-slider>

Demo

Note: significantDigits and precisionDigits can't be applied at the same time.


Smart.Slider supports big numbers as well. The wordLength property determines the range of numbers the element can display.

The available word lengths are:

  • int8 : from –128 to 127
  • uint8 : from 0 to 255
  • int16 : from –32,768 to 32,767
  • uint16 : from 0 to 65,535
  • int32 : from –2,147,483,648 to 2,147,483,647. Default value.
  • uint32 : from 0 to 4,294,967,295
  • int64 : from –9,223,372,036,854,775,808 to 9,223,372,036,854,775,807
  • uint64 : from 0 to 18,446,744,073,709,551,615

Here's how to set it as attribute:

<smart-slider word-length="uint8"></smart-slider>

Demo

The mechanicalAction property of the element determines when the value will change. This property determines the behavior of the element. Possible values are:

  • switchUntilReleased - changes the value while the user is dragging the thumb. When the thumb is released the value is returned to it's initial position.
  • switchWhenReleased - changes the value only when the thumb is released. Otherwise the value remains unchanged.
  • switchWhileDragging - changes the value while the user is dragging the thumb and retains the last value when the thumb is released. The default value of the property.
<smart-slider mechanical-action="switchWhenReleased"></smart-slider>

Demo

Coerce property determines the value iteration. Once enabled the element uses the interval property to determines the next possible selectable value from the scale.

By setting the interval property the user can control the interval between the values. Interval is a property of type number and can be set on initialization or using javascript:

<!DOCTYPE html>
<html lang="en">
<head>
 <link rel="stylesheet" href="../../source/styles/smart.default.css" type="text/css" />
 <script type="text/javascript" src="../../source/modules/smart.slider.js"></script>

 <script>
     window.onload = function () {
         var slider = document.querySelector('smart-slider');
         slider.interval = 10;
         slider.coerce = true;
     }
 </script>
</head>
<body>
 <smart-slider></smart-slider>
</body>
</html>

Demo

If coerce is enabled the thumb will snap to the next value based on the interval.


The slider element can behave like a range selector using two thumbs. The property rangeSlider determines if the second thumb is enabled or not. If applied the user can set a range value via the values property using javascript:

<!DOCTYPE html>
<html lang="en">
<head>
 <link rel="stylesheet" href="../../source/styles/smart.default.css" type="text/css" />
 <script type="text/javascript" src="../../source/modules/smart.slider.js"></script>
 <script>
     window.onload = function () {
         var slider = document.querySelector('smart-slider');
         slider.values = [50, 80];
     }
 </script>
</head>
<body>
 <smart-slider range-slider></smart-slider>
</body>
</html>

Demo

in the tag of the element during initialization:

<smart-slider range-slider values='[50, 80]'></smart-slider>

Demo

or use the thumbs on the scale to calibrate the values directly.

The property value is not used when rangeSlider is enabled.

Keyboard Support

Smart.Slider implements the following keys:

Key Action
Arrow Up / Arrow Right Increases the value or moves the second thumb forward if rangeSlider is enabled.
Arrow Left / Arrow Down Decreases the value or moves the first thumb backwards if rangeSlider is enabled.
Home Sets the value to min or moves the first thumb to the beginning if rangeSlider is enabled.
End Sets the value to max or moves the second thumb to the end if rangeSlider is enabled.

Append to the DOM:

const container = document.getElementById('slider-container');
container.appendChild(slider);
	

Remove from the DOM:

slider.remove();
	

Set a property:

slider.disabled = true;
slider.theme = 'dark';
	

Get a property value:

const isDisabled = slider.disabled;
const currentTheme = slider.theme;
	

Invoke a method:

slider.refresh();
slider.focus();
	

Add event listener:

slider.addEventListener('change', (event) => {
    console.log('change triggered:', event.detail.value);
});
	

Remove event listener:

const handleSliderEvent = (event) => {
    console.log('change triggered:', event.detail.value);
};

slider.addEventListener('change', handleSliderEvent);
slider.removeEventListener('change', handleSliderEvent);
	

Accessibility

The Slider component follows WAI-ARIA best practices:

  • Keyboard navigation - Tab, Arrow keys, Enter, and Escape are supported
  • ARIA roles - Appropriate roles and labels are applied automatically
  • Focus management - Visible focus indicators for keyboard users
  • Screen readers - State changes are announced to assistive technology
  • High contrast - Supports Windows High Contrast Mode and forced colors

For custom labeling, set aria-label or aria-labelledby attributes on the component.

Live demos

Supported stacks: Smart UI targets Angular 17+, React 18+, Vue 3+, Node 18 LTS, and evergreen browsers; pin exact package versions to your org policy.

Getting Started with React Slider Component

Smart UI React targets React 18+ and current Node LTS for tooling; use TypeScript templates when you want typed props and events.

Demo source (Smart UI repo): react/source/slider/basic/App.jsx

1 Create a Vite + React + TypeScript app

  1. npm create vite@latest my-smart-app -- --template react-ts
  2. cd my-smart-app
    then
    npm install

2 Install Smart UI for React

npm install smart-webcomponents-react

3 Import styles and render the component

Open src/App.tsx (or App.jsx if you chose JavaScript). The snippet below matches Smart UI React demos for this widget:

import 'smart-webcomponents-react/source/styles/smart.default.css';
import './App.css';
import React, { useRef } from "react";
import { Slider } from 'smart-webcomponents-react/slider';

const App = () => {
    const horizontalSliderValue = useRef(null);
    const verticalSliderValue = useRef(null);
    const invertedHorizontalSliderValue = useRef(null);
    const invertedVerticalSliderValue = useRef(null);

    const handleHorizontalSliderChange = (event) => {
        horizontalSliderValue.current.innerHTML = parseFloat(event.detail.value).toFixed(2);
    };

    const handleVerticalSliderChange = (event) => {
        verticalSliderValue.current.innerHTML = parseFloat(event.detail.value).toFixed(2);
    };

    const handleInvertedHorizontalSliderChange = (event) => {
        invertedHorizontalSliderValue.current.innerHTML = parseFloat(event.detail.value).toFixed(2);
    };

    const handleInvertedVerticalSliderChange = (event) => {
        invertedVerticalSliderValue.current.innerHTML = parseFloat(event.detail.value).toFixed(2);
    };

    return (
        <div>
            <div className="container">
                <div className="underlined">Horizontal slider</div>Value: <span ref={horizontalSliderValue} id="horizontalSliderValue">30.00</span>
                <Slider id="horizontalSlider" showTooltip orientation="horizontal"
                    min="0" max="100" value="30" scalePosition="none" onChange={handleHorizontalSliderChange}></Slider>
                <br />
                <div className="underlined">Vertical slider</div>Value: <span ref={verticalSliderValue} id="verticalSliderValue">30.00</span>
                <Slider id="verticalSlider" showTooltip tooltipPosition="far" orientation="vertical"
                    min="0" max="100" value="30" scalePosition="none" onChange={handleVerticalSliderChange}></Slider>
            </div>
            <div className="container">
                <div className="underlined">Inverted horizontal slider</div>Value: <span ref={invertedHorizontalSliderValue} id="invertedHorizontalSliderValue">30.00</span>
                <Slider id="invertedHorizontalSlider" showTooltip orientation="horizontal"
                    inverted min="0" max="100" value="30" scalePosition="none" onChange={handleInvertedHorizontalSliderChange}></Slider>
                <br />
                <div className="underlined">Inverted vertical slider</div>Value: <span ref={invertedVerticalSliderValue} id="invertedVerticalSliderValue">30.00</span>
                <Slider id="invertedVerticalSlider" showTooltip tooltipPosition="far"
                    orientation="vertical" inverted min="0" max="100" value="30" scalePosition="none" onChange={handleInvertedVerticalSliderChange}></Slider>
            </div>
        </div>
    );
};

export default App;

4 Run the dev server

npm run dev

Open the URL Vite prints (often http://localhost:5173/).

Alternative: Next.js

Create an app with npx create-next-app@latest (Pages Router or App Router). Install the same package (npm install smart-webcomponents-react), then reuse the imports and default export from step 3 in pages/_app.tsx, the App Router root app/layout.tsx, or your top-level layout component so styles and the widget tree load once.

TypeScript Support

Types ship with smart-webcomponents-react. Import the component and prop types:

import type { Slider, SliderProps } from 'smart-webcomponents-react/slider';

The generated wrappers expose on* callbacks (for example onChange) whose arguments are standard DOM Event values unless the widget typings narrow them further.

Accessibility

The Slider component follows WAI-ARIA best practices:

  • Keyboard navigation - Tab, Arrow keys, Enter, and Escape are supported
  • ARIA roles - Appropriate roles and labels are applied automatically
  • Focus management - Visible focus indicators for keyboard users
  • Screen readers - State changes are announced to assistive technology
  • High contrast - Supports Windows High Contrast Mode and forced colors

For custom labeling, set aria-label or aria-labelledby attributes on the component.

Live demos

Supported stacks: Smart UI targets Angular 17+, React 18+, Vue 3+, Node 18 LTS, and evergreen browsers; pin exact package versions to your org policy.

Angular Slider - Setup

Smart UI for Angular supports both standalone components (bootstrapApplication) and NgModule-based apps (bootstrapModule(AppModule)). Steps 1-5 show the standalone path; the section below shows the NgModule path with the same package and styles.

Demo source (Smart UI repo): angular/src/slider/basic

1 NPM Install

Install the smart-webcomponents-angular package:

npm install smart-webcomponents-angular

2 Register styles

Add the default Smart UI stylesheet to angular.json -> projects -> <your-project> -> architect -> build -> options -> styles (merge with existing entries):

"styles": [
		"node_modules/smart-webcomponents-angular/source/styles/smart.default.css"
	]

Add optional theme CSS from the same package after smart.default.css if you use Bootstrap, Fluent, or other bundled themes.

3 Import the Angular module

Import SliderModule from smart-webcomponents-angular/slider: use @Component.imports for standalone, or add it to your AppModule (or feature module) imports array for NgModule apps.

import { SliderModule } from 'smart-webcomponents-angular/slider';

4 Root component (standalone)

Add SliderModule to your root standalone component (src/app/app.ts). Snippet from Smart UI demos (paths normalized to app.html / App where applicable):

 import { Component, ViewChild, OnInit, AfterViewInit, ElementRef } from '@angular/core';
import { SliderComponent } from 'smart-webcomponents-angular/slider';

import { SliderModule } from 'smart-webcomponents-angular/slider';

@Component({
  selector: 'app-root',
  standalone: true,
  imports: [ SliderModule ],
  templateUrl: './app.html',
  styleUrl: './app.css'
})

export class App implements AfterViewInit, OnInit {
    @ViewChild('slider', { read: SliderComponent, static: false }) slider!: SliderComponent;
    @ViewChild('slider2', { read: SliderComponent, static: false }) slider2!: SliderComponent;
    @ViewChild('slider3', { read: SliderComponent, static: false }) slider3!: SliderComponent;
    @ViewChild('slider4', { read: SliderComponent, static: false }) slider4!: SliderComponent;
    @ViewChild('horizontalSliderValue', { read: ElementRef, static: false }) horizontalSliderValue!: ElementRef;
    @ViewChild('verticalSliderValue', { read: ElementRef, static: false }) verticalSliderValue!: ElementRef;
    @ViewChild('invertedHorizontalSliderValue', { read: ElementRef, static: false }) invertedHorizontalSliderValue!: ElementRef;
    @ViewChild('invertedVerticalSliderValue', { read: ElementRef, static: false }) invertedVerticalSliderValue!: ElementRef;

    ngOnInit(): void {
        // onInit code.
    }

    ngAfterViewInit(): void {
        // afterViewInit code.
        this.init();
    }

    init(): void {
        // init code.
        const that = this,
            sliders = [that.slider, that.slider2, that.slider3, that.slider4];

        for (let i = 0; i < sliders.length; i++) {
            const slider = sliders[i];

            slider.addEventListener('change', function (event: CustomEvent) {
                const value = event.detail.value;
                //@ts-ignore
                that[slider.nativeElement.id + 'Value'].nativeElement.innerHTML = parseFloat('' + value).toFixed(2);
            } as EventListener);
        }
    }
}

Boot the app with bootstrapApplication from src/main.ts and an ApplicationConfig in src/app/app.config.ts as generated by the CLI.

5 Template (standalone)

Use your markup in src/app/app.html (or inline template). Bind properties and events on smart-slider as needed:

 <div class="container">
    <div class="underlined">Horizontal slider</div>Value: <span id="horizontalSlider[value]" #horizontalSliderValue>30.00</span>
    <smart-slider #slider id="horizontalSlider" [showTooltip]="true" [orientation]="'horizontal'" [min]="0"
                  [max]="100" [value]="30" [scalePosition]="'none'"></smart-slider>
    <br />
    <div class="underlined">Vertical slider</div>Value: <span id="verticalSlider[value]" #verticalSliderValue>30.00</span>
    <smart-slider #slider2 id="verticalSlider" [showTooltip]="true" [tooltipPosition]="'far'" [orientation]="'vertical'"
                  [min]="0" [max]="100" [value]="30" [scalePosition]="'none'"></smart-slider>
</div>
<div class="container">
    <div class="underlined">Inverted horizontal slider</div>Value: <span id="invertedHorizontalSlider[value]" #invertedHorizontalSliderValue>30.00</span>
    <smart-slider #slider3 id="invertedHorizontalSlider" [showTooltip]="true" [orientation]="'horizontal'"
                  [inverted]="true" [min]="0" [max]="100" [value]="30" [scalePosition]="'none'"></smart-slider>
    <br />
    <div class="underlined">Inverted vertical slider</div>Value: <span id="invertedVerticalSlider[value]" #invertedVerticalSliderValue>30.00</span>
    <smart-slider #slider4 id="invertedVerticalSlider" [showTooltip]="true" [tooltipPosition]="'far'"
                  [orientation]="'vertical'" [inverted]="true" [min]="0" [max]="100" [value]="30" [scalePosition]="'none'"></smart-slider>
</div>

6 NgModule bootstrap (also supported)

Same npm package and angular.json styles as steps 1-2. Put SliderModule on your NgModule.imports instead of @Component.imports, and bootstrap with bootstrapModule(AppModule).

The demo sources bundled for this widget use standalone only (there is no app.module.ts in that folder). NgModule is fully supported: put SliderModule from smart-webcomponents-angular/slider on NgModule.imports, make your root component non-standalone (remove standalone: true and move widget modules from @Component.imports to the module), and bootstrap with platformBrowserDynamic().bootstrapModule(AppModule).

Minimal main.ts + app.module.ts pairing (adjust paths to match your CLI layout):

src/main.ts

import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { AppModule } from './app/app.module';

platformBrowserDynamic().bootstrapModule(AppModule).catch((err) => console.error(err));

src/app/app.module.ts

import { NgModule } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import { SliderModule } from 'smart-webcomponents-angular/slider';

@NgModule({
	declarations: [ AppComponent ],
	imports: [ BrowserModule, SliderModule ],
	bootstrap: [ AppComponent ]
})
export class AppModule { }

Reuse the template and class logic from steps 4-5 in AppComponent, configured for declarations + NgModule.imports instead of a standalone @Component.

Run

ng serve or npm start - then open http://localhost:4200/.

Smart UI for Angular - full documentation

Accessibility

The Slider component follows WAI-ARIA best practices:

  • Keyboard navigation - Tab, Arrow keys, Enter, and Escape are supported
  • ARIA roles - Appropriate roles and labels are applied automatically
  • Focus management - Visible focus indicators for keyboard users
  • Screen readers - State changes are announced to assistive technology
  • High contrast - Supports Windows High Contrast Mode and forced colors

For custom labeling, set aria-label or aria-labelledby attributes on the component.

Live demos

Supported stacks: Smart UI targets Angular 17+, React 18+, Vue 3+, Node 18 LTS, and evergreen browsers; pin exact package versions to your org policy.